﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDock;
using Infragistics.Win.UltraWinTabs;

namespace WD_FlyoutOnClick
{
    public partial class Form1 : Form
    {
        DockableControlPane clickToFlyoutPane = null;
        bool flyoutPane = false;

        public Form1()
        {
            InitializeComponent();

            clickToFlyoutPane = ultraDockManager1.ControlPanes[ultraExplorerBar1];
        }

        private void ultraDockManager1_BeforeShowFlyout(object sender, Infragistics.Win.UltraWinDock.CancelableControlPaneEventArgs e)
        {
            e.Cancel = e.Pane.Text == clickToFlyoutPane.Text && flyoutPane == false;
        }

        private void ultraDockManager1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            var tabUIElement = e.Element as TabItemUIElement;
            if (tabUIElement != null && tabUIElement.TabItem.Text == clickToFlyoutPane.Text)
            {
                tabUIElement.Control.MouseDown += Control_MouseDown;
            }
        }

        private void ultraDockManager1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            var tabUIElement = e.Element as TabItemUIElement;
            if (tabUIElement != null && tabUIElement.TabItem.Text == clickToFlyoutPane.Text)
            {
                tabUIElement.Control.MouseDown -= Control_MouseDown;
               
            }
        }

        // Basically a click event for the TabItemUIElement of the clickToFlyoutPane
        void Control_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                flyoutPane = true;
                clickToFlyoutPane.Flyout();
                flyoutPane = false;
            }
        }

    }
}
